
#setwd("/Volumes/encrypted/ccasanet/gabriela")
# setwd("~/Dropbox/datasim/long-term-mortality")

rm(list=ls())

#d<-read.csv("../oct2014/art.csv")
d<-read.csv("../output/art_sim.csv")

d$art<-as.character(d$art_id)

d$class<-with(d, ifelse(nnrti>=1&pi==0,"NNRTI",
               ifelse(nnrti==0&pi>=1&rtv_drug=="Yes","Boosted PI",
               ifelse(nnrti==0&pi>=1&rtv_drug=="No","Unboosted PI","Other"))))

d$id<-as.character(d$patient)
d$start.date<-as.Date(d$art_sd)
d$stop.date<-as.Date(d$art_ed)
d$reason<-d$art_rs
d$reason.oth<-d$art_rs_oth

unique.id<-unique(d$id)


#####  Data cleaning.  Checking those people who have multiple start dates on the same day. 
# duplicate.days<-rep(NA,length(unique.id))
# for (i in 1:length(unique.id)) {
#   duplicate.days[i]<-max(table(start.date[id==unique.id[i]]))>1
# }
# unique.id[duplicate.days==TRUE]



ord<-with(d,order(id,start.date))
d<-d[ord,]

locate1<-duplicated(d$id)


# locate1<-rep(NA,length(unique.id))
# for (i in 1:length(unique.id)) {
#   if (length(unique(start.date[id==unique.id[i]&!is.na(start.date)])) >=1) {
#     locate1[i]<-which(id.site==unique.id[i]&
#                       start.date==min(start.date[id==unique.id[i]],na.rm=TRUE))
#   }
# }



pid<-d$id[!locate1]
psite<-as.character(d$site[!locate1])
init.reg<-d$art[!locate1]
init.class<-d$class[!locate1]
init.start.date<-d$start.date[!locate1]
haart<-d$art_class[!locate1]


unique.id.art<-data.frame(id=pid,site=psite,
						  init.reg,init.class,init.start.date,haart)

#d.basic<-read.csv("../oct2014/basic.csv")
d.basic<-read.csv("../output/basic_sim.csv")

d1<-merge(unique.id.art,d.basic,by.x=c("id","site"),by.y=c("patient","site"))


d1$recart_y<-ifelse(is.na(d1$recart_y),9,d1$recart_y)
table(d1$recart_y,d1$site)

# Karu has already made the switch in the data he sent me.
# recart_y<-with(d1, ifelse(site=="argentina"&init.start.date<as.Date(baseline_d)-90,1,
#                       ifelse(site=="argentina"&init.start.date>=as.Date(baseline_d)-90,0,recart_y)))

d1$age<-with(d1,ifelse(d1$birth_d_a!="U",floor( (as.numeric(as.Date(init.start.date)) -as.numeric(as.Date(birth_d)) )/365.25),NA))


clin.trial<-function(a){
  stuff<-ifelse(a=="MRV/PBO"|a=="RAL/PBO"|a=="EFV/PBO",1,0)
  stuff
}
d1$init.clin.trial<-sapply(lapply(lapply(strsplit(as.character(d1$init.reg),','),clin.trial),sum),FUN=as.numeric)


d.close<-as.Date(ifelse(d1$site=="argentina"|d1$site=="haiti"|d1$site=="honduras","2013-01-01","2014-01-01"))   ##### Database closing date

exclude.unknown.age<-ifelse(d1$birth_d=="1900-01-01"|d1$birth_d_a=="U"|d1$birth_d=="",1,0)
exclude.age<-ifelse(d1$age<18,1,0)
exclude.recart<-ifelse(d1$recart_y!=0,1,0)  
exclude.nonHAART.reg1<-ifelse(d1$haart=="non-HAART",1,0)
exclude.before2000<-ifelse(d1$init.start.date<as.Date("2000-01-01"),1,0)
#exclude.clin.trial<-ifelse(d1$init.clin.trial>0|d1$second.clin.trial>0|d1$clinicaltrial_y>0,1,0)
exclude.peru2004<-ifelse(d1$site=="peru"&d1$init.start.date<as.Date("2005-01-01"),1,0)
exclude.start.after.d.close<-ifelse(d1$init.start.date>d.close,1,0)

####  Anyone who started HAART more than 90 days before their firstvisit in Argentina should be excluded.  Karu has done this, by setting them as recart_y=1.
# with(d1,sum(init.start.date[site=="argentina"]<as.Date(baseline_d[site=="argentina"])-90&recart_y[site=="argentina"]==0))


exclude<-ifelse(exclude.unknown.age==1|exclude.age==1|exclude.recart==1|
                  exclude.nonHAART.reg1==1|exclude.before2000==1|exclude.peru2004==1|exclude.start.after.d.close==1,1,0)  ### currently not excluding based on clinical trial

exclude.code1<-ifelse(exclude.unknown.age==1,"Age unknown",
               ifelse(exclude.age==1,"Age < 18",
               ifelse(exclude.before2000==1,"ART started before 2000",
               ifelse(exclude.recart==1,"Not known to be ART naive at enrollment",
               ifelse(exclude.nonHAART.reg1==1,"First Regimen not HAART",
               ifelse(exclude.peru2004==1,"ART started before 2005 in Peru",
               ifelse(exclude.start.after.d.close,"ART started after closing date","Included")))))))
exclude.code<-factor(exclude.code1, levels=c("Age unknown","Age < 18","ART started before 2000","Not known to be ART naive at enrollment",
                                             "First Regimen not HAART","ART started before 2005 in Peru","ART started after closing date","Included"),
                     ordered=TRUE)



table.exclude<-table(exclude,as.character(d1$site))
table.exclude.reason<-table(exclude.code,as.character(d1$site))

table.exclude.reason
                     
                     
included<-d1[exclude==0,]




save(included,table.exclude,table.exclude.reason,file="included-art.rda")
 
