
#####  Computing LTFU

rm(list=ls())

#setwd("/Volumes/encrypted/ccasanet/gabriela")
# setwd("~/Dropbox/datasim/long-term-mortality")
load("d-second-chunk.Rda")

summary(d$last.date[d$site=="argentina"])
summary(d$last.date[d$site=="brazil"])
summary(d$last.date[d$site=="chile"])
summary(d$last.date[d$site=="haiti"])
summary(d$last.date[d$site=="honduras"])
summary(d$last.date[d$site=="mexico"])
summary(d$last.date[d$site=="peru"])

# d.close.a<-max(d$last.date[d$site=="argentina"])  #as.Date("2012-10-31")
# d.close.b<-max(d$last.date[d$site=="brazil"])
# d.close.c<-max(d$last.date[d$site=="chile"])
# #d.close.c<-as.Date("2010-12-31")              
# d.close.h<-max(d$last.date[d$site=="haiti"])
# d.close.ho<-max(d$last.date[d$site=="honduras"])
# d.close.m<-max(d$last.date[d$site=="mexico"])
# d.close.p<-max(d$last.date[d$site=="peru"])
# 
# d.close<-as.Date(ifelse(d$site=="argentina",as.character(d.close.a),
#                         ifelse(d$site=="brazil",as.character(d.close.b),
#                                ifelse(d$site=="chile",as.character(d.close.c),
#                                       ifelse(d$site=="haiti",as.character(d.close.h),
#                                              ifelse(d$site=="honduras",as.character(d.close.ho),
#                                                     ifelse(d$site=="mexico",as.character(d.close.m),
#                                                            ifelse(d$site=="peru",as.character(d.close.p),"1900-01-01"))))))))


#d.close<-as.Date(ifelse(d$site=="argentina"|d$site=="haiti"|d$site=="honduras","2012-01-01","2014-01-01"))   ###  This is already computed in gabriela-first-chunk.R
#d.close<-as.Date("2013-01-01")

lost1<-ifelse(d$death1==0&d$last.date<d.close-365,1,0)

d.lost<-data.frame(id=d$id,site=d$site,lost1=lost1,
                   last.date=d$last.date,d.close=d.close,death1=d$death1)
with(d.lost, table(lost1,site))
round(with(d.lost, table(lost1,site)[2,]/colSums(table(lost1,site))),3)

##########   Removing those who have transferred

d.follow<-read.csv("../output/follow_sim.csv")
d.follow$transfer<-with(d.follow,ifelse(drop_rs=="Patient transfered"|drop_rs=="Patient moved away"|drop_rs=="Consent withdrawn"|
                                        drop_rs_oth=="insurance change"|drop_rs_oth=="INSURANCE CHANGE"|drop_rs_oth=="patient tranferred"|drop_rs_oth=="patient transferred"|
                                        drop_rs_oth=="referred to elite controllers clinical trial"|drop_rs_oth=="Traslado al CAI Hosp escuela"|
                                        drop_rs_oth=="PACIENTE PERDIO SU TRABAJO Y FUE TRASLADADO AL CENTRO DE SLUD ALONZO SUAZO",1,0))

d.follow1<-data.frame(id=as.character(d.follow$patient),transfer=d.follow$transfer)
d.lost<-merge(d.lost,d.follow1,by.x="id",by.y="id",all.x=TRUE) 

d.lost$lost1<-with(d.lost, ifelse(transfer==1,0,d.lost$lost1))

####  Now merging with the larger dataset

dlost<-merge(d.lost,d,by=c("id","site"),all=TRUE)      

dlost$init.class.cat<-ifelse(dlost$init.class=="Other"|dlost$init.class=="Unboosted PI",
                       "Other",as.character(dlost$init.class))
dlost$init.class.cat<-factor(dlost$init.class.cat, levels=c("NNRTI","Boosted PI","Other"), ordered=TRUE)
dlost$death1<-dlost$death1.x
dlost$status<-with(dlost,ifelse(lost1==0&death1==0,"alive",
                         ifelse(lost1==0&death1==1,"dead",
                         ifelse(lost1==1,"ltfu","PROBLEM"))))

lost.stats<-function(dlost,site.select){ 
  age.lost0<-with(dlost, summary(age[lost1==0&site==site.select]))[c(2,3,5)]
  age.lost1<-with(dlost, summary(age[lost1==1&site==site.select]))[c(2,3,5)]
  age.lostp<-with(dlost, wilcox.test(age~lost1,subset=site==site.select))$p.value
  
  cd4.lost0<-with(dlost, summary(nadir.cd4.prehaart[lost1==0&site==site.select]))[c(2,3,5)]
  cd4.lost1<-with(dlost, summary(nadir.cd4.prehaart[lost1==1&site==site.select]))[c(2,3,5)]
  cd4.lostp<-with(dlost, wilcox.test(nadir.cd4.prehaart~lost1,subset=site==site.select))$p.value
  
  year.lost0<-with(dlost, summary(year.init[lost1==0&site==site.select]))[c(2,3,5)]
  year.lost1<-with(dlost, summary(year.init[lost1==1&site==site.select]))[c(2,3,5)]
  year.lostp<-with(dlost, wilcox.test(year.init~lost1,subset=site==site.select))$p.value
  
  male.lost01<-with(dlost, table(male[site==site.select],lost1[site==site.select])[2,])
  male.lost01p<-with(dlost, table(male[site==site.select],lost1[site==site.select])[2,]/table(lost1[site==site.select]))
  male.lostp<-with(dlost, chisq.test(table(lost1[site==site.select],male[site==site.select])))$p.value
  
  aids.lost01<-with(dlost, table(aids.enrollment[site==site.select],lost1[site==site.select])[1,])
  aids.lost01p<-with(dlost, table(aids.enrollment[site==site.select],lost1[site==site.select])[1,]/table(lost1[site==site.select&aids.enrollment!="Unknown"]))
  aids.lostp<-with(dlost, chisq.test(table(aids.enrollment[site==site.select&aids.enrollment!="Unknown"],lost1[site==site.select&aids.enrollment!="Unknown"])))$p.value
  
  init.class.lost0<-with(dlost, table(init.class.cat[site==site.select],lost1[site==site.select])[,1])
  init.class.lost1<-with(dlost, table(init.class.cat[site==site.select],lost1[site==site.select])[,2])
  init.class.lost0p<-with(dlost, table(init.class.cat[site==site.select],lost1[site==site.select])[,1]/sum(lost1[site==site.select]==0))
  init.class.lost1p<-with(dlost, table(init.class.cat[site==site.select],lost1[site==site.select])[,2]/sum(lost1[site==site.select]==1))
  init.class.lostp<-with(dlost, chisq.test(table(init.class.cat[site==site.select],lost1[site==site.select])))$p.value
  
  dlost.site<-c(age.lost0,age.lost1,age.lostp,
                cd4.lost0,cd4.lost1,cd4.lostp,
                year.lost0,year.lost1,year.lostp,
                male.lost01,male.lost01p,male.lostp,
                aids.lost01,aids.lost01p,aids.lostp,
                init.class.lost0,init.class.lost1,init.class.lost0p,init.class.lost1p,init.class.lostp)
  names(dlost.site)<-c("age.lost0.Q1","age.lost0.Q2","age.lost0.Q3","age.lost1.Q1","age.lost1.Q2","age.lost1.Q3","age.lost.pval",
                       "cd4.lost0.Q1","cd4.lost0.Q2","cd4.lost0.Q3","cd4.lost1.Q1","cd4.lost1.Q2","cd4.lost1.Q3","cd4.lost.pval",
                       "year.lost0.Q1","year.lost0.Q2","year.lost0.Q3","year.lost1.Q1","year.lost1.Q2","year.lost1.Q3","year.lost.pval",
                       "nmale.lost0","nmale.lost1","pmale.lost0","pmale.lost1","male.lost.pval",
                       "naids.lost0","naids.lost1","paids.lost0","paids.lost1","aids.lost.pval",
                       "nnnrti.lost0","nboostedpi.lost0","nother.lost0",
                       "nnnrti.lost1","nboostedpi.lost1","nother.lost1",
                       "pnnrti.lost0","pboostedpi.lost0","pother.lost0",
                       "pnnrti.lost1","pboostedpi.lost1","pother.lost1","init.class.pval"
 )
  
  dlost.site
}

stuff.a<-lost.stats(dlost,site.select="argentina")
stuff.b<-lost.stats(dlost,site.select="brazil")
stuff.c<-lost.stats(dlost,site.select="chile")
stuff.h<-lost.stats(dlost,site.select="haiti")
stuff.ho<-lost.stats(dlost,site.select="honduras")
stuff.m<-lost.stats(dlost,site.select="mexico")
stuff.p<-lost.stats(dlost,site.select="peru")

stats.on.lost<-rbind(stuff.a,stuff.b,stuff.c,
                     stuff.h,stuff.ho,stuff.m,stuff.p)


table.lost<-table(dlost$lost1,dlost$site)



status.stats<-function(dlost,site.select){ 
  age.alive<-with(dlost, summary(age[status=="alive"&site==site.select]))[c(2,3,5)]
  age.dead <-with(dlost, summary(age[status=="dead"&site==site.select]))[c(2,3,5)]
  age.ltfu <-with(dlost, summary(age[status=="ltfu"&site==site.select]))[c(2,3,5)]
  age.lost.alive.p<-with(dlost, wilcox.test(age~status,subset=(site==site.select&status!="dead")))$p.value
  age.lost.dead.p<-with(dlost, wilcox.test(age~status,subset=(site==site.select&status!="alive")))$p.value
  
  cd4.alive<-with(dlost, summary(nadir.cd4.prehaart[status=="alive"&site==site.select]))[c(2,3,5)]
  cd4.dead<-with(dlost, summary(nadir.cd4.prehaart[status=="dead"&site==site.select]))[c(2,3,5)]
  cd4.ltfu<-with(dlost, summary(nadir.cd4.prehaart[status=="ltfu"&site==site.select]))[c(2,3,5)]
  cd4.lost.alive.p<-with(dlost, wilcox.test(nadir.cd4.prehaart~status,subset=(site==site.select&status!="dead")))$p.value
  cd4.lost.dead.p<-with(dlost, wilcox.test(nadir.cd4.prehaart~status,subset=(site==site.select&status!="alive")))$p.value
  
  year.alive<-with(dlost, summary(year.init[status=="alive"&site==site.select]))[c(2,3,5)]
  year.dead<-with(dlost, summary(year.init[status=="dead"&site==site.select]))[c(2,3,5)]
  year.ltfu<-with(dlost, summary(year.init[status=="ltfu"&site==site.select]))[c(2,3,5)]
  year.lost.alive.p<-with(dlost, wilcox.test(year.init~status,subset=(site==site.select&status!="dead")))$p.value
  year.lost.dead.p<-with(dlost, wilcox.test(year.init~status,subset=(site==site.select&status!="alive")))$p.value
  
  male.status1<-with(dlost, table(male[site==site.select],status[site==site.select])[2,])
  male.status1p<-with(dlost, table(male[site==site.select],status[site==site.select])[2,]/table(status[site==site.select]))
  male.lost.alive.p<-with(dlost, chisq.test(table(status[site==site.select&status!="dead"],male[site==site.select&status!="dead"])))$p.value
  male.lost.dead.p<-with(dlost, chisq.test(table(status[site==site.select&status!="alive"],male[site==site.select&status!="alive"])))$p.value
  
  aids.status1<-with(dlost, table(aids.enrollment[site==site.select],status[site==site.select])[1,])
  aids.status1p<-with(dlost, table(aids.enrollment[site==site.select],status[site==site.select])[1,]/table(status[site==site.select]))
  aids.lost.alive.p<-with(dlost, chisq.test(table(status[site==site.select&status!="dead"&aids.enrollment!="Unknown"],aids.enrollment[site==site.select&status!="dead"&aids.enrollment!="Unknown"])))$p.value
  aids.lost.dead.p<-with(dlost, chisq.test(table(status[site==site.select&status!="alive"&aids.enrollment!="Unknown"],aids.enrollment[site==site.select&status!="alive"&aids.enrollment!="Unknown"])))$p.value
  
  init.class.alive<-with(dlost, table(init.class.cat[site==site.select],status[site==site.select])[,1])
  init.class.dead<-with(dlost, table(init.class.cat[site==site.select],status[site==site.select])[,2])
  init.class.ltfu<-with(dlost, table(init.class.cat[site==site.select],status[site==site.select])[,3])
  init.class.alivep<-with(dlost, table(init.class.cat[site==site.select],status[site==site.select])[,1]/sum(status[site==site.select]=="alive"))
  init.class.deadp<-with(dlost, table(init.class.cat[site==site.select],status[site==site.select])[,2]/sum(status[site==site.select]=="dead"))
  init.class.ltfup<-with(dlost, table(init.class.cat[site==site.select],status[site==site.select])[,3]/sum(status[site==site.select]=="ltfu"))
  init.class.lost.alive.p<-with(dlost, chisq.test(table(init.class.cat[site==site.select&status!="dead"],status[site==site.select&status!="dead"])))$p.value
  init.class.lost.dead.p<-with(dlost, chisq.test(table(init.class.cat[site==site.select&status!="alive"],status[site==site.select&status!="alive"])))$p.value
  
  dlost.site<-c(age.alive,age.dead,age.ltfu,age.lost.alive.p,age.lost.dead.p,
                cd4.alive,cd4.dead,cd4.ltfu,cd4.lost.alive.p,cd4.lost.dead.p,
                year.alive,year.dead,year.ltfu,year.lost.alive.p,year.lost.dead.p,
                male.status1,male.status1p,male.lost.alive.p,male.lost.dead.p,
                aids.status1,aids.status1p,aids.lost.alive.p,aids.lost.dead.p,
                init.class.alive,init.class.dead,init.class.ltfu,init.class.alivep,init.class.deadp,init.class.ltfup,
                init.class.lost.alive.p,init.class.lost.dead.p)
  names(dlost.site)<-c("age.alive.Q1","age.alive.Q2","age.alive.Q3","age.dead.Q1","age.dead.Q2","age.dead.Q3",
                       "age.ltfu.Q1","age.ltfu.Q2","age.ltfu.Q3","age.lost.alive.pval","age.lost.dead.pval",
                       "cd4.alive.Q1","cd4.alive.Q2","cd4.alive.Q3","cd4.dead.Q1","cd4.dead.Q2","cd4.dead.Q3",
                       "cd4.ltfu.Q1","cd4.ltfu.Q2","cd4.ltfu.Q3","cd4.lost.alive.pval","cd4.lost.dead.pval",
                       "year.alive.Q1","year.alive.Q2","year.alive.Q3","year.dead.Q1","year.dead.Q2","year.dead.Q3",
                       "year.ltfu.Q1","year.ltfu.Q2","year.ltfu.Q3","year.lost.alive.pval","year.lost.dead.pval",
                       "nmale.alive","nmale.dead","nmale.ltfu","pmale.alive","pmale.dead","pmale.ltfu",
                       "male.lost.alive.pval","male.lost.dead.pval",
                       "naids.alive","naids.dead","naids.ltfu","paids.alive","paids.dead","paids.ltfu",
                       "aids.lost.alive.pval","aids.lost.dead.pval",
                       "nnnrti.alive","nboostedpi.alive","nother.alive",
                       "nnnrti.dead","nboostedpi.dead","nother.dead",
                       "nnnrti.ltfu","nboostedpi.ltfu","nother.ltfu",
                       "pnnrti.alive","pboostedpi.alive","pother.alive",
                       "pnnrti.dead","pboostedpi.dead","pother.dead",
                       "pnnrti.ltfu","pboostedpi.ltfu","pother.ltfu",
                       "init.class.lost.alive.pval","init.class.lost.dead.pval"
  )
  
  dlost.site
}

stuff.a<-status.stats(dlost,site.select="argentina")
stuff.b<-status.stats(dlost,site.select="brazil")
stuff.c<-status.stats(dlost,site.select="chile")
stuff.h<-status.stats(dlost,site.select="haiti")
stuff.ho<-status.stats(dlost,site.select="honduras")
stuff.m<-status.stats(dlost,site.select="mexico")
stuff.p<-status.stats(dlost,site.select="peru")

stats.on.status<-rbind(stuff.a,stuff.b,stuff.c,
                     stuff.h,stuff.ho,stuff.m,stuff.p)


table.status<-table(dlost$status,dlost$site)



d.comb<-d.lost[,-which(names(d.lost)=="death1")]    ####  Quick fix on August 22, 2013.  NEED TO FIX

save(table.lost,stats.on.lost, d.comb, table.status, stats.on.status, file="ltfu-gabriela.rda")







# ######################
# #######  Some extra stuff for Brazil because they asked for patients LTFU in the entire cohort:
# 
# rm(list=ls())
# d.follow<-read.csv("../data-current/follow.csv")
# 
# d<-d.follow[d.follow$site=="brazil",]
# 
# d.close.b<-max(as.Date(d$l_alive_d[d$l_alive_d!="2013-11-07"]))
# 
# #d.close.b<-as.Date("2013-03-21")
# 
# d$lost<-ifelse(d$death_y==0&as.Date(d$l_alive_d)<d.close.b-365,1,0)
# 
# d.lost<-d[d$lost==1,]
# 
# write.csv(d.lost,file="lost-ids-brazil-total-2013-06-26.csv",row.names=FALSE)

