
rm(list=ls())

#setwd("/Volumes/encrypted/ccasanet/gabriela")
# setwd("~/Dropbox/datasim/long-term-mortality")

load("included-art.rda")

#included<-included[which(included$init.start.date>=as.Date("2001-01-01")&included$recart_y==0),]  #Did this in first chunk already

# d.cd4<-read.csv("../oct2014/lab_cd4.csv")
# d.rna<-read.csv("../oct2014/lab_rna.csv")
# d.follow<-read.csv("../oct2014/follow.csv")
# d.visit<-read.csv("../oct2014/visit.csv")
d.cd4<-read.csv("../output/lab_cd4_sim.csv")
d.rna<-read.csv("../output/lab_rna_sim.csv")
d.follow<-read.csv("../output/follow_sim.csv")
d.visit<-read.csv("../output/visit_sim.csv")




d1<-merge(included,d.follow,by.x=c("id","site"),by.y=c("patient","site"),all.x=TRUE)
d1$site<-as.character(d1$site)

table(d1$death_y)
mean(d1$death_y)


########

d1$date.death<-as.Date(as.character(d1$death_d),"%Y-%m-%d")
d1$date.death.a<-d1$death_d_a 
table(d1$death_y,d1$date.death.a)


####  Patients who died but are missing a date of death
cbind(d1$id[d1$death_y==1&is.na(d1$date.death)],as.character(d1$site[d1$death_y==1&is.na(d1$date.death)]))

cbind(d1$id[d1$death_y==1&d1$date.death.a=="U"],as.character(d1$site[d1$death_y==1&d1$date.death.a=="U"]))

cbind(d1$id[d1$death_y==0&d1$date.death.a=="U"],as.character(d1$site[d1$death_y==0&d1$date.death.a=="U"]))


d1$init.class<-as.character(d1$init.class)


####  AIDS at HAART initiation computed in file "CCASAnet-ADE-definition-R-code.R"

load("AIDSstatus.rda")

d1<-merge(d1,AIDSstatus,by.x=c("id","site"), by.y=c("patient","site"), all.x=TRUE)



head(d.cd4)
d.cd4$date<-as.Date(d.cd4$cd4_d,"%Y-%m-%d")
d.cd4$site<-as.character(d.cd4$site)
d.cd4$patient<-as.character(d.cd4$patient)


d1$nadir.cd4.prehaart <- NA
d1$date.nadir.cd4.prehaart <- NA

for (i in seq(nrow(d1))) {
  ix <- which(d.cd4$patient == d1[i,'id'] & d.cd4$site == d1[i,'site'] & d.cd4$date <= d1[i,'init.start.date']+7)
  if(length(ix)) {
    set <- d.cd4[ix, c('cd4_v', 'date')]
    # take minimum cd4 value from subset
    d1[i, c('nadir.cd4.prehaart', 'date.nadir.cd4.prehaart')] <- set[which.min(set[,'cd4_v']),]
  }
} 

summary(as.numeric(d1$init.start.date)-as.numeric(d1$date.nadir.cd4.prehaart))




d.rna$date<-as.Date(d.rna$rna_d,"%Y-%m-%d")
d.rna$undetect.vl<-ifelse(d.rna$rna_v<=0,1,0)

d1$site<-as.character(d1$site)
d.rna$site<-as.character(d.rna$site)
d.rna$patient<-as.character(d.rna$patient)

locate.rna.prehaart<-rep(NA,length(d1$id))
for (i in 1:length(d1$id)) {
  if (sum(!is.na(d.rna$rna_v[d.rna$patient==d1$id[i] & d.rna$site==d1$site[i] & d.rna$date <= d1$init.start.date[i]
                         & d.rna$date >= d1$init.start.date[i]-180 & !is.na(d.rna$date)]))>=1) {
    locate.rna.prehaart[i]<-
      which(d1$init.start.date[i]-d.rna$date==
              min(d1$init.start.date[i]-d.rna$date[d.rna$patient==d1$id[i] & d.rna$site==d1$site[i] & d.rna$date <= d1$init.start.date[i] 
                                                   & d.rna$date >= d1$init.start.date[i]-180],na.rm=TRUE)
            & d.rna$patient==d1$id[i] & d.rna$site==d1$site[i] & d.rna$date <= d1$init.start.date[i] & d.rna$date >= d1$init.start.date[i]-180)[1]
  }
}

d1$rna1<-d.rna$rna_v[locate.rna.prehaart]
d1$undetect1<-d.rna$undetect.vl[locate.rna.prehaart]
d1$rna1.date<-d.rna$date[locate.rna.prehaart]

###  Undetectable VL at initiation is likely error
summary(d1$rna1)
sum(d1$undetect1,na.rm=TRUE)
prob1<-ifelse(d1$undetect1==0,0,1)
prob<-ifelse(is.na(prob1),0,prob1)
cbind(as.character(d1$site[prob==1]),as.character(d1$id[prob==1]),as.character(d1$rna1[prob==1]),as.character(d1$rna1.date[prob==1]),as.character(d1$init.start.date[prob==1]))

table(prob,d1$site)

d1$male<-as.character(d1$male)
d<-d1


####  Potential covariates
##  site
##  gender
##  probable mode of infection
##  nadir CD4 before starting HAART
##  class of initial regimen
##  date of initiating initial regimen


table(d$site)
table(d$male,d$site)

d$route<-ifelse(d$mode=="Homo/Bisexual"|
                d$mode=="Bisexual"|
                d$mode=="Homosexual contact","homo/bisexual",
          ifelse(d$mode=="Heterosexual contact and Injecting drug user"|
                 d$mode=="Homo/Bisexual and Injecting drug user"|
                 d$mode=="Injecting drug user","IDU",
          ifelse(d$mode=="Heterosexual contact","heterosexual",
          ifelse(d$mode=="Unknown","unknown",
          ifelse(d$mode=="","missing","other")))))
d$idu<-ifelse(d$route=="IDU",1,
               ifelse(d$route=="Unknown",NA,0))
table(d$mode)
table(d$route)
table(d$route,d$site)
table(d$idu,d$site)

table(d$init.class,d$site)




summary(d$nadir.cd4.prehaart)
boxplot(d$nadir.cd4.prehaart~d$site)


summary(d$init.start.date)

junk1<-strsplit(as.character(d$init.start.date),split="-")
year.init<-NULL
for (i in 1:length(d$init.start.date)) {
  year.init[i]<-as.numeric(junk1[[i]][1])
}

d$year.init<-year.init




d.close<-as.Date(ifelse(d$site=="argentina"|d$site=="haiti"|d$site=="honduras","2013-01-01","2014-01-01"))   ##### Database closing date

######  I need to watch out for approximate dates here.  I have now done this.  (2014-10-21)

table(d1$death_y,d1$date.death.a)
table(d1$site[d1$death_y==1],d1$date.death.a[d1$death_y==1])

sum(d1$death_y)
with(d1,sum(death_y==1&(date.death.a=="M"|date.death.a=="Y"|date.death.a=="U"|date.death.a=="<"|date.death.a==">")))
with(d1,sum(death_y==1&(date.death.a=="M"|date.death.a=="Y"|date.death.a=="U"|date.death.a=="<"|date.death.a==">")))/sum(d1$death_y)

cbind(as.character(d1$id[d1$death_y==1&d1$date.death.a==">"]),as.character(d1$date.death[d1$death_y==1&d1$date.death.a==">"]))
cbind(as.character(d1$id[d1$death_y==1&d1$date.death.a=="M"]),as.character(d1$date.death[d1$death_y==1&d1$date.death.a=="M"]))
cbind(as.character(d1$id[d1$death_y==1&d1$date.death.a=="Y"]),as.character(d1$date.death[d1$death_y==1&d1$date.death.a=="Y"]))
cbind(as.character(d1$id[d1$death_y==1&d1$date.death.a=="U"]),as.character(d1$date.death[d1$death_y==1&d1$date.death.a=="U"]),as.character(d1$l_alive_d[d1$death_y==1&d1$date.death.a=="U"]))

sum(is.na(d$date.death)&d$death_y==1)

junk1<-strsplit(as.character(d$date.death),split="-")
year.death<-month.death<-NULL
for (i in 1:length(d$date.death)) {
  year.death[i]<-as.numeric(junk1[[i]][1])
  month.death[i]<-as.numeric(junk1[[i]][2])
}

d<-within(d, {
         death1<-ifelse(!is.na(date.death),1,0)
 #        death1<-ifelse(is.na(date.death)|date.death=="1900-01-01",0,death)   ### leftover from old code
         ### Those patients whose date of death is unknown will be censored at their last visit date when I use 'death1'
      #   last.date<-as.Date(ifelse(death1==1,as.character(date.death),as.character(l_alive_d)), "%Y-%m-%d")
         last.date<-as.Date(
                            ifelse(death1==1&(date.death.a=="D"|date.death.a==""),as.character(date.death),
                            ifelse(death1==1&date.death.a=="M",as.character(paste(year.death,month.death,"15",sep="-")),   ## death death known to month assigned on the 15th
                            ifelse(death1==1&date.death.a==">"|date.death.a=="U",as.character(date.death+60),   ## unknown date of death assigned 2 months after last visit
                            ifelse(death1==1&date.death.a=="<",as.character(date.death-60),                     ## unknown date of death assigned 2 months prior to last visit
                                   as.character(l_alive_d))))), 
                                   "%Y-%m-%d")
         time<-as.numeric(pmin(last.date,d.close)-init.start.date) 
                    })
# 
# 
library(survival)

with(d,{
  plot(survfit(Surv(time,death1)~1),xlim=c(0,2560),ylim=c(0,.3), conf.int=TRUE, mark.time=FALSE, xlab="Years from Start of Second Regimen",
       ylab="Probability of Death", axes=FALSE, fun="event")
  axis(2)
  axis(1,at=c(365*(0:10)),label=c(0:10))
})

#pdf("quick-plot.pdf")
with(d,{
  S.a<-Surv(time[site=="argentina"],death1[site=="argentina"])
  S.b<-Surv(time[site=="brazil"],death1[site=="brazil"])
  S.c<-Surv(time[site=="chile"],death1[site=="chile"])
  S.h<-Surv(time[site=="haiti"],death1[site=="haiti"])
  S.ho<-Surv(time[site=="honduras"],death1[site=="honduras"])
  S.m<-Surv(time[site=="mexico"],death1[site=="mexico"])
  S.p<-Surv(time[site=="peru"],death1[site=="peru"])

  plot(survfit(Surv(time,death1)~site),xlim=c(0,2560),ylim=c(0,.3), conf.int=FALSE, mark.time=FALSE, xlab="Years from Start of Second Regimen",
       ylab="Probability of Death", axes=FALSE,fun="event")
  axis(2)
  axis(1,at=c(365*(0:10)),label=c(0:10))
  lines(survfit(S.a~1), mark.time=FALSE, col=2, fun="event")
  lines(survfit(S.b~1), mark.time=FALSE, col=3, fun="event")
  lines(survfit(S.c~1), mark.time=FALSE, col=4, fun="event")
  lines(survfit(S.h~1), mark.time=FALSE, col=5, fun="event")
  lines(survfit(S.ho~1), mark.time=FALSE, col=6, fun="event")
  lines(survfit(S.m~1), mark.time=FALSE, col=7, fun="event")
  lines(survfit(S.p~1), mark.time=FALSE, col=8, fun="event")

  legend("topleft",c("Argentina","Brazil","Chile","Haiti","Honduras","Mexico","Peru"),col=c(2:8),lty=rep(1,7))
})
#dev.off()
# 
# 


d$aids.enrollment<-d$preARTAIDS.clinical

save(d,d.close,file="d-second-chunk.Rda")




